package de.jg_cody.Teraplex.ui.settings;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Vibrator;
import android.util.Base64;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;

import java.util.Locale;
import java.util.Objects;

import de.jg_cody.Teraplex.MainActivity;
import de.jg_cody.Teraplex.R;

import static android.content.Context.MODE_PRIVATE;

public class SettingsFragment extends Fragment {

    private EditText editExportFile_name;
    private SettingsViewModel settingsViewModel;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        settingsViewModel =
                new ViewModelProvider(this).get(SettingsViewModel.class);
        View root = inflater.inflate(R.layout.fragment_settings, container, false);
        SharedPreferences p = requireContext().getSharedPreferences("appsettings", Activity.MODE_PRIVATE);
        String Background = p.getString("Background", null);
        if (Background != null) {
            ImageView I = root.findViewById(R.id.Background);
            byte[] BA = Base64.decode(Background, Base64.DEFAULT);
            I.setImageDrawable(new BitmapDrawable(getResources(), MainActivity.scaleCenterCrop(BitmapFactory.decodeByteArray(BA, 0, BA.length), MainActivity.getScreenHeight(), MainActivity.getScreenWidth())));
            I.setScaleType(ImageView.ScaleType.CENTER_CROP);
        }
        Button Language = root.findViewById(R.id.button_language);
        Language.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                showChangeLanguageDialog();

            }
        });
        Button Export = root.findViewById(R.id.button_export);
        Export.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                showExportDialog();
            }
        });
        Button Import = root.findViewById(R.id.button_import);
        Import.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                showImportDialog();
            }
        });
        Button Reset = root.findViewById(R.id.button_reset);
        Reset.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                MediaPlayer mp = MediaPlayer.create(getContext(), R.raw.alert_error);
                mp.start();
                AlertDialog mDialog = new AlertDialog.Builder(getContext())
                        .setTitle(R.string.reset_app)
                        .setMessage(R.string.are_you_sure_to_reset)

                        // Specifying a listener allows you to take an action before dismissing the dialog.
                        // The dialog is automatically dismissed when a dialog button is clicked.
                        .setPositiveButton(android.R.string.yes, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
                                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                                assert vr != null;
                                vr.vibrate(100);
                                try {
                                    requireContext().getSharedPreferences("appsettings", Context.MODE_PRIVATE).edit().clear().apply();
                                    startActivity(requireActivity().getIntent());
                                    requireActivity().finish();
                                } catch (Exception ignored) {
                                }

                                // Continue with delete operation
                            }
                        })

                        // A null listener allows the button to dismiss the dialog and take no further action.
                        .setNegativeButton(getString(R.string.cancel), new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialogInterface, int i) {
                                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                                assert vr != null;
                                vr.vibrate(100);
                            }
                        }).create();
                Objects.requireNonNull(mDialog.getWindow()).setBackgroundDrawableResource(R.drawable.button_round);
                mDialog.getWindow().getAttributes().windowAnimations = R.style.DialogAnimation; //style id
                mDialog.show();
            }

        });
        Button choose_background = root.findViewById(R.id.button_pickimage);
        choose_background.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                showChangeBackgroundDialog();


            }
        });
        Button theme1 = root.findViewById(R.id.button_theme_red_blue);
        theme1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                SharedPreferences.Editor editor = requireContext().getSharedPreferences("appsettings", MODE_PRIVATE).edit();
                editor.putString("Theme", "RED_BLUE");
                editor.apply();
                startActivity(requireActivity().getIntent());
                requireActivity().finish();


            }
        });
        Button theme2 = root.findViewById(R.id.button_theme_green_yellow);
        theme2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                SharedPreferences.Editor editor = requireContext().getSharedPreferences("appsettings", MODE_PRIVATE).edit();
                editor.putString("Theme", "GREEN_YELLOW");
                editor.apply();
                startActivity(requireActivity().getIntent());
                requireActivity().finish();


            }
        });
        Button theme3 = root.findViewById(R.id.button_theme_orange_turquoise);
        theme3.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                SharedPreferences.Editor editor = requireContext().getSharedPreferences("appsettings", MODE_PRIVATE).edit();
                editor.putString("Theme", "ORANGE_TURQUOISE");
                editor.apply();
                startActivity(requireActivity().getIntent());
                requireActivity().finish();


            }
        });
        Button theme4 = root.findViewById(R.id.button_theme_yellow_blue);
        theme4.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                SharedPreferences.Editor editor = requireContext().getSharedPreferences("appsettings", MODE_PRIVATE).edit();
                editor.putString("Theme", "YELLOW_BLUE");
                editor.apply();
                startActivity(requireActivity().getIntent());
                requireActivity().finish();


            }
        });
        Button theme5 = root.findViewById(R.id.button_theme_pink_green);
        theme5.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                SharedPreferences.Editor editor = requireContext().getSharedPreferences("appsettings", MODE_PRIVATE).edit();
                editor.putString("Theme", "PINK_GREEN");
                editor.apply();
                startActivity(requireActivity().getIntent());
                requireActivity().finish();


            }
        });

        return root;
    }

    private void showChangeLanguageDialog() {
        final String[] listItems = {"GERMAN", "ENGLISCH"};
        AlertDialog.Builder mBuilder = new AlertDialog.Builder(getContext());
        mBuilder.setTitle(getString(R.string.choose_language));
        mBuilder.setSingleChoiceItems(listItems, -1, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                if (i == 0) {
                    setLocale("de");
                    startActivity(requireActivity().getIntent());
                    requireActivity().finish();
                } else if (i == 1) {
                    setLocale("en");
                    startActivity(requireActivity().getIntent());
                    requireActivity().finish();
                }
                dialogInterface.dismiss();
            }
        });
        AlertDialog mDialog = mBuilder.create();
        Objects.requireNonNull(mDialog.getWindow()).setBackgroundDrawableResource(R.drawable.button_round);
        mDialog.getWindow().getAttributes().windowAnimations = R.style.DialogAnimation; //style id
        mDialog.show();
    }

    private void showChangeBackgroundDialog() {
        final String[] listItems = {getString(R.string.image), getString(R.string.reset_background)};
        AlertDialog.Builder mBuilder = new AlertDialog.Builder(getContext());
        mBuilder.setTitle(getString(R.string.choose_backgroundtype));
        mBuilder.setSingleChoiceItems(listItems, -5, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                if (i == 0) {
                    Intent a = new Intent(
                            Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
                    requireActivity().startActivityForResult(a, MainActivity.RESULT_LOAD_IMAGE);
                } else if (i == 1) {
                    requireContext().getSharedPreferences("appsettings", Context.MODE_PRIVATE).edit().remove("Background").apply();
                    startActivity(requireActivity().getIntent());
                    requireActivity().finish();

                }
                dialogInterface.dismiss();
            }
        });
        AlertDialog mDialog = mBuilder.create();
        Objects.requireNonNull(mDialog.getWindow()).setBackgroundDrawableResource(R.drawable.button_round);
        mDialog.getWindow().getAttributes().windowAnimations = R.style.DialogAnimation; //style id
        mDialog.show();
    }

    private void setLocale(String lang) {
        Locale locale = new Locale(lang);
        Locale.setDefault(locale);
        Configuration config = new Configuration();
        config.locale = locale;
        requireContext().getResources().updateConfiguration(config, requireContext().getResources().getDisplayMetrics());
        SharedPreferences.Editor editor = requireContext().getSharedPreferences("appsettings", MODE_PRIVATE).edit();
        editor.putString("Language", lang);
        editor.apply();
    }
    private void showExportDialog() {
        final String[] listItems = {"EXPORT BACKGROUND", "EXPORT LANGUAGESETTINGS", "EXPORT THEMESETTINGS", "EXPORT TABS"};
        AlertDialog.Builder mBuilder = new AlertDialog.Builder(getContext());
        mBuilder.setTitle(getString(R.string.export_settings));
        mBuilder.setMultiChoiceItems(listItems, null, new DialogInterface.OnMultiChoiceClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i, boolean b) {
                Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                assert vr != null;
                vr.vibrate(100);
                if (i == 0) {

                } else if (i == 1) {

                } else if (i == 2) {

                } else if (i == 3) {

                }
            }

        });
        mBuilder.setPositiveButton(getString(R.string.button_export), new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
                LayoutInflater inflater = requireActivity().getLayoutInflater();
                View view = inflater.inflate(R.layout.exportdialog, null);

                editExportFile_name = view.findViewById(R.id.dialogexport_editText_name);


                builder.setView(view)
                        .setTitle("SINGLE BUTTON")
                        .setNegativeButton(getString(R.string.cancel), (dialogExport, r) -> {

                        })
                        .setPositiveButton(R.string.button_export, (dialogExport, r) -> {
                            String headline = editExportFile_name.getText().toString();
                            if(headline.isEmpty()){
                                MediaPlayer mp = MediaPlayer.create(getContext(), R.raw.state_change_confirm_up);
                                mp.start();
                                AlertDialog mDialog = new AlertDialog.Builder(getContext())
                                        .setTitle(getString(R.string.invalid))
                                        .setMessage(getString(R.string.inputfields_cant_be_empty))

                                        // Specifying a listener allows you to take an action before dismissing the dialog.
                                        // The dialog is automatically dismissed when a dialog button is clicked.
                                        .setPositiveButton(android.R.string.yes, null )
                                        .create();
                                Objects.requireNonNull(mDialog.getWindow()).setBackgroundDrawableResource(R.drawable.button_round);
                                mDialog.getWindow().getAttributes().windowAnimations = R.style.DialogAnimation; //style id
                                mDialog.show();
                                return;
                            }

                        });


                AlertDialog mDialog = builder.create();
                Objects.requireNonNull(mDialog.getWindow()).setBackgroundDrawableResource(R.drawable.button_round);
                mDialog.getWindow().getAttributes().windowAnimations = R.style.DialogAnimation; //style id
                mDialog.show();
                }
            }
        );
        mBuilder.setNegativeButton(getString(R.string.cancel), new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {

            }
        });
        AlertDialog mDialog = mBuilder.create();
        Objects.requireNonNull(mDialog.getWindow()).setBackgroundDrawableResource(R.drawable.button_round);
        mDialog.getWindow().getAttributes().windowAnimations = R.style.DialogAnimation; //style id
        mDialog.show();
    }
    private void showImportDialog() {
        Intent a = new Intent(
                Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
        requireActivity().startActivityForResult(a, MainActivity.RESULT_LOAD_IMAGE);
    }

}